{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Graf.TView.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Graf.TView.RawType
import HROOT.Graf.TView.FFI
import HROOT.Graf.TView.Interface
import HROOT.Graf.TView.Cast
import HROOT.Graf.TView.RawType
import HROOT.Graf.TView.Cast
import HROOT.Graf.TView.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITView (TView) where
        front = xform0 c_tview_front
        frontView = xform1 c_tview_frontview
        getLatitude = xform0 c_tview_getlatitude
        getLongitude = xform0 c_tview_getlongitude
        getPsi = xform0 c_tview_getpsi
        isViewChanged = xform0 c_tview_isviewchanged
        rotateView = xform2 c_tview_rotateview
        setLatitude = xform1 c_tview_setlatitude
        setLongitude = xform1 c_tview_setlongitude
        setPsi = xform1 c_tview_setpsi
        setView1 = xform4 c_tview_setview1
        setViewChanged = xform1 c_tview_setviewchanged
        side = xform0 c_tview_side
        sideView = xform1 c_tview_sideview
        top = xform0 c_tview_top
        topView = xform1 c_tview_topview

instance () => ITObject (TView) where
        clear = xform1 c_tview_clear
        draw = xform1 c_tview_draw
        findObject = xform1 c_tview_findobject
        getName = xform0 c_tview_getname
        isA = xform0 c_tview_isa
        paint = xform1 c_tview_paint
        printObj = xform1 c_tview_printobj
        saveAs = xform2 c_tview_saveas
        write = xform3 c_tview_write
        write_ = xform0 c_tview_write_

instance () => ITAttLine (TView) where
        getLineColor = xform0 c_tview_getlinecolor
        getLineStyle = xform0 c_tview_getlinestyle
        getLineWidth = xform0 c_tview_getlinewidth
        resetAttLine = xform1 c_tview_resetattline
        setLineAttributes = xform0 c_tview_setlineattributes
        setLineColor = xform1 c_tview_setlinecolor
        setLineStyle = xform1 c_tview_setlinestyle
        setLineWidth = xform1 c_tview_setlinewidth

instance () => IDeletable (TView) where
        delete = xform0 c_tview_delete
